#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2013/12/22 17:15:16 +0900>

require 'dxruby'

#
#= DXRubypBGA^NX
#
# ^Cō\ꂽBG}bvf[^ɂĒn`A^܂B
#
# * DXRuby KvB摜XLɎgĂ܂B
#
# @version 0.1 2013/12/22
#
class BgAtari

  # W␳ȂBĂ邩ǂׂ
  ADJUST_NONE = 0

  # ɍW␳
  ADJUST_UP = 1

  # ɍW␳
  ADJUST_DOWN = 2

  # ɍW␳
  ADJUST_LEFT = 3

  # EɍW␳
  ADJUST_RIGHT = 4

  # @return [Array] BGA^p}bvf[^(񎟌z)
  attr_reader :mapdata

  # @return [int] BG}bv̉^C
  attr_reader :width

  # @return [int] BG}bv̏c^C
  attr_reader :height

  # @return [int] ^C̉hbg
  attr_reader :tilewidth

  # @return [int] ^C̏chbg
  attr_reader :tileheight

  # @return [int] BG}bv̉hbg
  attr_reader :map_width

  # @return [int] BG}bv̏chbg
  attr_reader :map_height

  # @return [int] ʂ߂鉡^C
  attr_reader :screenwidth

  # @return [int] ʂ߂c^C
  attr_reader :screenheight

  # @return [int] `FbNWɂBGA^ԍ
  attr_reader :bg_code

  # @return [int] ␳ x W
  attr_reader :adjust_x

  # @return [int] ␳ y W
  attr_reader :adjust_y

  # @return [Boolean] Xɕ␳Kvȉ\ȂtrueAłȂfalse
  attr_reader :continue_tile

  # @return [Array] ^CA^ʗpf[^
  attr_reader :atari_tbls

  #
  # RXgN^
  #
  # ^C摜XLăe[u쐬B
  #
  # @param [Array] imgarr Imagez
  # @param [Array] mapdata }bvf[^(񎟌z)
  # @param [int] scrw ʉhbg
  # @param [int] scrh ʏchbg
  # @param [int] nullcode ƂĈA^ԍ
  # @param [int] no_floor_start ƂĈȂA^̊Jnԍ(Ԃ牺_)
  # @param [int] no_floor_end ƂĈȂA^̏Iԍ(Ԃ牺_)
  #
  # @note 摜năA^pf[^쐬Ă܂A
  #       炩ߔzf[^ēn悤ɏC΁A
  #       ̃Cułg悤ɂȂ邩܂B
  #
  def initialize(imgarr, mapdata, scrw, scrh,
                 nullcode = 0,
                 no_floor_start = 0x7fffffff,
                 no_floor_end   = 0x7fffffff)

    @bg_code = 0
    @continue_tile = false
    @adjust_x = 0 # ␳̍W
    @adjust_y = 0

    @nullcode = nullcode
    @no_floor_start = no_floor_start
    @no_floor_end = no_floor_end
    @atari_tbls = {}
    @mapdata = mapdata

    # BG}bv̏c^CL^
    @width = mapdata[0].length
    @height = mapdata.length

    # ^C̃hbgTCYL^
    @tilewidth = imgarr[0].width
    @tileheight = imgarr[0].height

    # BG}bṽhbgTCYL^
    @map_width = @tilewidth * @width
    @map_height = @tileheight * @height

    # ʂ߂^CL^
    @screenwidth = (scrw.to_f / @tilewidth).ceil
    @screenheight = (scrh.to_f / @tileheight).ceil

    # e^C̃A^pf[^쐬B
    # ŁAe^C摜̃hbgăf[^쐬Ă邪A
    # 炩߃f[^zēn΁A
    # ̃Cułg悤ɂȂƎvc
    @mapdata.each do |lines|
      lines.each do |i|
        unless @atari_tbls.key?(i)
          img = imgarr[i]
          @atari_tbls[i] = make_tile_atari_table(img)
        end
      end
    end
    # pp @atari_tbls
  end

  #
  # 1^C̃A^pf[^쐬
  #
  # @param [Image] img ^C摜(DXRubyImageIuWFNg)
  #
  # @return [Array] A^pf[^z
  #
  def make_tile_atari_table(img)
    tbls = []
    w, h = img.width, img.height

    # ㉺ŎgA^pe[u쐬
    tbl = []
    w.times do |x|
      ymin = nil
      ymax = nil
      h.times do |y|
        unless ymin
          # hbgH
          ymin = y if img[x, y][0] > 128
        end
        unless ymax
          # hbgH
          ymax = ((h - 1) - y) if img[x, (h - 1) - y][0] > 128
        end
      end
      tbl.push([ymin, ymax])
    end
    tbls.push(tbl)

    # ẼA^pe[u쐬
    tbl = []
    h.times do |y|
      xmin = nil
      xmax = nil
      w.times do |x|
        unless xmin
          # hbgH
          xmin = x if img[x, y][0] > 128
        end
        unless xmax
          # hbgH
          xmax = ((w - 1) - x) if img[(w - 1) - x, y][0] > 128
        end
      end
      tbl.push([xmin, xmax])
    end
    tbls.push(tbl)

    return tbls
  end

  #
  # wWBGA^ԍ擾
  #
  # @param [int] x xW
  # @param [int] y yW
  #
  # @return [int] BGA^ԍ
  #
  def get_bg_code(x, y)
    tx = ((x.to_i % @map_width) / @tilewidth).to_i
    ty = ((y.to_i % @map_height) / @tileheight).to_i
    @bg_code = @mapdata[ty][tx]
    return @bg_code
  end

  #
  # BGA^ƓĂ邩Ԃ
  #
  # * ŌɓBGA^ԍ @bg_code ɋL^B
  # * ␳W擾A܂␳Kvȉ\ȂA
  #   @continue_tile  true ɂȂB
  #
  # @param [int] x xW
  # @param [int] y yW
  # @param [int] dir ␳BADJUST_(NONE|UP|DOWN|LEFT|RIGHT)w\B
  # @param [Boolean] floor_only trueȂ珰݂̂A
  #                             falseȂԂ牺_Ȃǂ`FbN
  #
  # @return [int] ADJUST_NONEȊOw莞́A␳lԂ
  # @return [Boolean] ADJUST_NONEw莞́AĂȂ true Ԃ
  # @return [nil] ɂĂȂȂ nil
  #
  def check_bg_hit(x, y, dir = ADJUST_NONE, floor_only = false)
    @continue_tile = false
    x = x.to_i
    y = y.to_i
    hx = x % @map_width
    hy = y % @map_height
    tx = (hx / @tilewidth).to_i
    ty = (hy / @tileheight).to_i
    code = @mapdata[ty][tx]

    # ŌɓBGA^ԍL^قȂcH
    @bg_code = code if code != @nullcode
    # @bg_code = code

    return nil if code == @nullcode

    unless floor_only
      # Ԃ牺_Ȃǂ́AR[hƂĈ
      return nil if @no_floor_start <= code and code <= @no_floor_end
    end

    ymin, ymax = @atari_tbls[code][0][hx % tilewidth]
    return nil if ymin == nil or ymax == nil
    chky = hy % tileheight
    return nil if chky < ymin or ymax < chky

    case dir
    when ADJUST_NONE
      # Ă邱ƂԂ
      return true

    when ADJUST_UP
      # ւ̕␳lԂ
      hosei = ymin - chky - 1
      @adjust_x = x
      @adjust_y = y + hosei
      @continue_tile = true if ymin == 0
      return hosei

    when ADJUST_DOWN
      # ւ̕␳lԂ
      hosei = ymax - chky + 1
      @adjust_x = x
      @adjust_y = y + hosei
      @continue_tile = true if ymax == (@tileheight - 1)
      return hosei

    else
      # A͉Eւ̕␳lԂ
      xmin, xmax = @atari_tbls[code][1][hy % tileheight]
      return nil if xmin == nil or xmax == nil
      chkx = hx % tilewidth

      # {Aȉ̏͐Ȃ͂cÔ߂ɓĂB
      # ł𑬂ȂRgAEg
      return nil if chkx < xmin or xmax < chkx

      case dir
      when ADJUST_LEFT
        # ւ̕␳lԂ
        hosei = xmin - chkx - 1
        @adjust_x = x + hosei
        @adjust_y = y
        @continue_tile = true if xmin == 0
        return hosei

      when ADJUST_RIGHT
        # Eւ̕␳lԂ
        hosei = xmax - chkx + 1
        @adjust_x = x + hosei
        @adjust_y = y
        @continue_tile = true if xmax == (@tilewidth - 1)
        return hosei

      end
    end
    return true
  end

  #
  # BGA^ŕ␳Wl𓾂
  #
  # ʉAc𒴂␳l͋߂ȂB
  #
  # @param [int] x xW
  # @param [int] y yW
  # @param [int] dir ␳BADJUST_(UP|DOWN|LEFT|RIGHT)w\B
  # @param [Boolean] floor_only trueȂ珰݂̂A
  #                             falseȂԂ牺_Ȃǂ`FbN
  #
  # @return [Array] ␳x,yWԂB
  #                 nil,nil ȂABGƓĂȂ̂ŕ␳ȂԂB
  #
  def adjust_bg_hit(x, y, dir = ADJUST_UP, floor_only = false)
    x = x.to_i
    y = y.to_i

    hosei = check_bg_hit(x, y, dir, floor_only)
    unless hosei
      # ␳Kv
      @bg_code = @nullcode
      return nil, nil
    end

    case dir
    when ADJUST_UP, ADJUST_DOWN
      # ㉺ɕ␳W𓾂
      code = @bg_code
      @screenheight.times do
        # [vɂȂȂ悤ɁA
        # ʂ߂[v
        y += hosei
        break unless @continue_tile
        hosei = check_bg_hit(x, y, dir, floor_only)
        unless hosei
          @bg_code = code
          break
        else
          code = @bg_code
        end
      end
      return x, y

    when ADJUST_LEFT, ADJUST_RIGHT
      # Eɕ␳W𓾂
      code = @bg_code
      @screenwidth.times do
        x += hosei
        break unless @continue_tile
        hosei = check_bg_hit(x, y, dir, floor_only)
        unless hosei
          @bg_code = code
          break
        else
          code = @bg_code
        end
      end
      return x, y
    end

    retun nil, nil
  end

  #
  # mFpB^CA^pf[^_v
  #
  def dump_tile_atari_data
    self.atari_tbls.keys.sort.each do |i|
      puts "\n"
      puts "# code = #{i}"
      p self.atari_tbls[i]
    end
  end
end

if __FILE__ == $0
  # Tv

  # BGA^ʗpf[^쐬Ɏg摜ǂݍ
  imgarr = Image.loadTiles("bg_attari.png", 256 / 16, 256 / 16)

  # }bvf[^
  mapdata = [
    [0, 0, 0, 0, 0, 0, 0, 0],
    [0, 1, 1, 1, 1, 1, 1, 1],
    [0, 0, 0, 0, 0, 0, 0, 0],
    [0, 0, 0, 0, 0, 0, 0, 0],
    [0, 3, 4, 5, 6, 7, 8, 9],
    [2, 2, 2, 2, 2, 2, 2, 2]
  ]

  bgatari = BgAtari.new(imgarr, mapdata, 640, 480, 0)

  # BGA^ԍ𓾂
  x, y = 20, 20
  code = bgatari.get_bg_code(x, y)
  puts "(#{x}, #{y}) BG code = #{code}"

  # BGƓĂ邩ׂ
  x, y = 20, 20
  puts "\n(#{x}, #{y}) BG hit check"

  chkhit = bgatari.check_bg_hit(x, y, BgAtari::ADJUST_NONE)
  if chkhit
    puts "Ă"
  else
    puts "ĂȂ"
  end

  # ␳W𓾂
  puts "\n(#{x}, #{y}) BG hit adjust up"
  hx, hy = bgatari.adjust_bg_hit(x, y, BgAtari::ADJUST_UP)
  if hx and hy
    puts "␳̍W : #{hx}, #{hy}"
  else
    puts "ĂȂ"
  end

  # ^CA^pf[^_v
  puts "\n^CA^pf[^\n\n"
  bgatari.dump_tile_atari_data
end
