#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2013/12/22 16:11:32 +0900>

require 'tmx'

#
#= DXRubypBG}bvǗNX
#
# }bvGfB^ Tiled ō쐬}bvt@C(.tmx)
# DXRubyŎgBG}bvf[^ɕϊ܂B
#
# * tmxCu[https://rubygems.org/gems/tmx] KvB
#
# @version 0.2 2013/12/22
#
class DxrbTmx

  # tmxCuœǂݍ .tmx IuWFNg
  attr_accessor :tmx

  # @return [Array] SC[̃}bvf[^(Oz)
  attr_reader :mapdata

  # @return [hash] C[̃nbV
  attr_reader :layers_name

  # @return [int] BG}bv̉^C
  attr_reader :width

  # @return [int] BG}bv̏c^C
  attr_reader :height

  # @return [int] ^C̉hbg
  attr_reader :tilewidth

  # @return [int] ^C̏chbg
  attr_reader :tileheight

  # @return [int] BG}bv̉hbg
  attr_reader :map_width

  # @return [int] BG}bv̏chbg
  attr_reader :map_height

  # @return [int] ʂ߂鉡^C
  attr_reader :screenwidth

  # @return [int] ʂ߂c^C
  attr_reader :screenheight

  #
  # RXgN^
  #
  # @param [String] tmxfile .tmxt@C̃pX
  # @param [int] scrw ʉhbg
  # @param [int] scrh ʏchbg
  #
  def initialize(tmxfile, scrw, scrh)
    init_map(tmxfile, scrw, scrh)
  end

  #
  # }bv̏
  #
  # @param [String] tmxfile .tmxt@C̃pX
  # @param [int] scrw ʉhbg
  # @param [int] scrh ʏchbg
  #
  def init_map(tmxfile, scrw, scrh)
    @tmx = Tmx.load(tmxfile)

    # }bv̏c^CL^
    @width = @tmx.width
    @height = @tmx.height

    # ^C̃hbgTCYL^
    @tilewidth = @tmx.tilewidth
    @tileheight = @tmx.tileheight

    # }bṽTCY(hbg) L^
    @map_width = @width * @tilewidth
    @map_height = @height * @tileheight

    @screenwidth = (scrw.to_f / @tilewidth).ceil
    @screenheight = (scrh.to_f / @tileheight).ceil

    # }bvpz
    @mapdata = []

    # C[ƃC[ԍ̑Ή
    @layers_name = {}

    # SC[̃}bvf[^ɌĂ
    layernum = 0
    @tmx.layers.each do |layer|
      name = layer.name # C[
      w = layer.width # C[TCY(^C)
      h = layer.height
      ltype = layer.type # C[

      @layers_name[name] = layernum

      maps = []
      i = 0
      @height.times do |my|
        lines = []
        @width.times do |mx|
          n = layer.data[i]
          # tmx0Ԃ̂ŃR[hԍ𒲐
          lines.push((n <= 0)? 0 : n - 1)
          i += 1
        end
        maps.push(lines)
      end
      @mapdata.push(maps)
      layernum += 1
    end
  end

  #
  # C[w肵āA}bvf[^(񎟌z)𓾂
  #
  # @param [String] layer_name C[
  #
  # @return [Array] }bvf[^(񎟌z)
  #
  def get_layer(layer_name)
    return @mapdata[@layers_name[layer_name]]
  end

  #
  # SC[Ԃ
  #
  # @return [int] SC[
  #
  def get_layers_length
    return @tmx.layers.length
  end

  #
  # mFpB}bvTCYƃ^CTCY_v
  #
  def dump_map_size
    puts "# tmx size"
    puts "map size = #{self.width} x #{self.height}"
    puts "tile size = #{self.tilewidth} x #{self.tileheight}"
    puts "layer length = #{self.get_layers_length}"
    puts "# end"
  end

  #
  # mFpBSC[(^CC[)̏_v
  #
  def dump_layers_info
    puts "# all layer info"
    @tmx.layers.each do |layer|
      name = layer.name  # C[
      w = layer.width    # C[TCY
      h = layer.height
      ltype = layer.type # C[
      data = layer.data # C[̃}bve[u
      puts "name: #{name} , #{w} x #{h} , type: #{ltype} , Data length: #{data.length}"
    end
    puts "# end"
  end

  #
  # mFpBIuWFNgC[_v
  #
  def dump_object_group_info
    puts "# object layer info"
    @tmx.object_groups.each do |objg|
      puts "object layer name : #{objg.name}"
      objg.objects.each do |o|
        name = o.name
        x = o.x
        y = o.y
        puts "#{name} , (#{x},#{y})"
      end
    end
    puts "# end"
  end

end

if __FILE__ == $0
  # Tv

  tmx = DxrbTmx.new("bg_atari_test.tmx", 640, 480)

  # dump
  tmx.dump_map_size
  tmx.dump_layers_info
  tmx.dump_object_group_info

  mapdata = tmx.get_layer("bg_atari")

  mapdata.each {|l| p l }

end
