#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2013/12/22 14:25:06 +0900>
#
#= Tiled .tmx ǂŁA\ƒn`A^Tv
#
# * J[\L[ŃJ[\ړ
# * WASDL[ŃXN[
# * BL[ŁABGA^C[\/\
# * HL[ŁAԂ牺_ƃA^Ƃ邩ۂؑ
# * ESCL[ŏI

require 'dxruby'
require 'tmx'
require_relative 'dxrbtmx'
require_relative 'bgatari'

font = Font.new(14)
Window.frameskip = false

# ʃTCY(hbg)擾
scrw = Window.width
scrh = Window.height

# BG`Ɏg^C摜ǂݍ
bgimg = Image.loadTiles("bg_attari.png", 256/16, 256/16)

# BG}bvt@C(.tmx)ǂݍ
tmx = DxrbTmx.new("./bg_atari_test.tmx", scrw, scrh)

# C[w肵āADXRuby̕`p}bvf[^(񎟌z)擾
atari_layer = tmx.get_layer("bg_atari")
bg_layer0 = tmx.get_layer("layer0")
bg_layer1 = tmx.get_layer("layer1")
bg_layer2 = tmx.get_layer("layer2")
bg_layer3 = tmx.get_layer("layer3")

# ʂ߂^C擾
bgtw = tmx.screenwidth
bgth = tmx.screenheight

# BGA^pe[u쐬
#
# ȉ̈n
#
# 1. A^p̉摜z(Image.loadTiles() œǂݍ񂾉摜)
# 2. BGA^}bvf[^(񎟌z)
# 3. ʉhbg
# 4. ʏchbg
# 5. A^ԍ (ȗ 0Ԃ𔲂ƂĈ)
# 6. 񏰃A^Jnԍ (ȗ\)
# 7. 񏰃A^Iԍ (ȗ\)
#
bgatari = BgAtari.new(bgimg, atari_layer, scrw, scrh, 0, 22, 30)

bx, by = 0, 0 # XN[ʒu
px, py = scrw / 2, scrh / 2 # J[\ʒu
atari_disp = true # BGA^`悷邩ǂ̃tO
floor = true # Ԃ牺_̃A^͖邩ۂ̃tO

# J[\`p\bh
def draw_cursor(x, y, col)
  w = 2
  Window.drawLine(x - w, y, x + w, y, col)
  Window.drawLine(x, y - w, x, y + (w + 1), col)
end

# C[v
Window.loop do
  break if Input.keyPush?(K_ESCAPE) # ESCL[ŏI

  # BL[ŁABGA^`悷邩Ȃ؂ւ
  atari_disp = !atari_disp if Input.keyPush?(K_B)

  # HL[ŁAԂ牺_A^𖳎邩Ȃ؂ւ
  floor = !floor if Input.keyPush?(K_H)

  # WASDL[ŃXN[
  spd = 4.0
  bx -= spd if Input.keyDown?(K_A)
  bx += spd if Input.keyDown?(K_D)
  by -= spd if Input.keyDown?(K_W)
  by += spd if Input.keyDown?(K_S)
  
  # J[\L[ŃJ[\ړ
  spd = 1.0
  px += Input.x * spd
  py += Input.y * spd

  # BG`
  if atari_disp
    # BGA^̂ݕ`
    Window.drawTile(0, 0, atari_layer, bgimg, bx, by, bgtw, bgth)
  else
    # ʏBĜݕ`
    Window.drawTile(0, 0, bg_layer3, bgimg, bx / 8, by / 8, bgtw, bgth)
    Window.drawTile(0, 0, bg_layer2, bgimg, bx / 4, by / 4, bgtw, bgth)
    Window.drawTile(0, 0, bg_layer1, bgimg, bx / 2, by / 2, bgtw, bgth)
    Window.drawTile(0, 0, bg_layer0, bgimg, bx, by, bgtw, bgth)
  end

  # J[\WBGA^ԍ擾
  x = bx + px
  y = by + py
  bg_code = bgatari.get_bg_code(x, y)

  # J[\WBGƓĂ邩`FbN
  chk_hit = bgatari.check_bg_hit(x, y, BgAtari::ADJUST_NONE, floor)
  col = (chk_hit)? [192, 255, 0, 0] : [192, 0, 128, 255]

  # J[\W`
  draw_cursor(px, py, col)

  # ␳W𓾂
  nx, ny = bgatari.adjust_bg_hit(x, y, BgAtari::ADJUST_UP, floor)
  hosei_code = bgatari.bg_code
  draw_cursor(nx - bx, ny - by, C_CYAN) if nx

  # V␳̍W𓾂
  nx, ny = bgatari.adjust_bg_hit(x, y, BgAtari::ADJUST_DOWN, floor)
  draw_cursor(nx - bx, ny - by, C_CYAN) if nx

  # Ǖ␳̍W𓾂
  nx, ny = bgatari.adjust_bg_hit(x, y, BgAtari::ADJUST_LEFT, floor)
  draw_cursor(nx - bx, ny - by, C_YELLOW) if nx
  
  nx, ny = bgatari.adjust_bg_hit(x, y, BgAtari::ADJUST_RIGHT, floor)
  draw_cursor(nx - bx, ny - by, C_YELLOW) if nx

  # BGA^ԍ̑̏`
  yh = 16
  Window.drawFont(16, yh * 0, "FPS: #{Window.real_fps}", font)
  Window.drawFont(16, yh * 1, "input CURSORAWASD,B,H key", font)
  Window.drawFont(16, yh * 2, "#{bg_code} : BG code", font)
  Window.drawFont(16, yh * 3, "#{hosei_code} : BG code (Floor adjust)", font)

end
